run-sample-tests.sh 8.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439
  1. #!/bin/sh
  2. # Copyright (c) 2019 Intel Corporation
  3. # SPDX-License-Identifier: Apache-2.0
  4. image=net-tools
  5. name=net-tools
  6. network=net-tools0
  7. zephyr_pid=0
  8. docker_pid=0
  9. configuration=""
  10. result=0
  11. dirs=""
  12. zephyr_overlay=""
  13. docker_test_script_name=docker-test.sh
  14. scan_dirs=0
  15. RUNNING_FROM_MAIN_SCRIPT=1
  16. check_dirs ()
  17. {
  18. local ret_zephyr=0
  19. local ret_net_tools=0
  20. if [ -z "$ZEPHYR_BASE" ]; then
  21. echo '$ZEPHYR_BASE is unset' >&2
  22. ret_zephyr=1
  23. elif [ ! -d "$ZEPHYR_BASE" ]; then
  24. echo '$ZEPHYR_BASE is set, but it is not a directory' >&2
  25. ret_zephyr=1
  26. fi
  27. if [ -z "$NET_TOOLS_BASE" ]; then
  28. local d
  29. for d in "$ZEPHYR_BASE/../.." "$ZEPHYR_BASE/.."
  30. do
  31. local l
  32. l="$d/net-tools"
  33. if [ -d "$l" ]; then
  34. NET_TOOLS_BASE="$l"
  35. break
  36. fi
  37. done
  38. fi
  39. if [ $ret_zephyr -eq 0 ]; then
  40. echo "\$ZEPHYR_BASE $ZEPHYR_BASE"
  41. fi
  42. if [ -z "$NET_TOOLS_BASE" ]; then
  43. echo '$NET_TOOLS_BASE is unset, no net-tools found' >&2
  44. ret_net_tools=1
  45. elif [ ! -d "$NET_TOOLS_BASE" ]; then
  46. echo '$NET_TOOLS_BASE set, but it is not a directory' >&2
  47. ret_net_tools=1
  48. fi
  49. if [ $ret_net_tools -eq 0 ]; then
  50. echo "\$NET_TOOLS_BASE $NET_TOOLS_BASE"
  51. fi
  52. if [ $ret_zephyr -ne 0 -o $ret_net_tools -ne 0 ]; then
  53. return 1
  54. fi
  55. return 0
  56. }
  57. scan_dirs ()
  58. {
  59. echo
  60. echo "Following directories under $ZEPHYR_BASE can be used by this script:"
  61. find "$ZEPHYR_BASE" -type f -name $docker_test_script_name | \
  62. awk -F "$ZEPHYR_BASE/" '{ print $2 }' | \
  63. sed "s/\/$docker_test_script_name//"
  64. }
  65. start_configuration ()
  66. {
  67. local bridge_interface=""
  68. local addresses="--ip=192.0.2.2 --ip6=2001:db8::2"
  69. if ! docker image ls | grep "$image" > /dev/null; then
  70. echo "Docker image '$image' not found" >&2
  71. return 1
  72. fi
  73. if ! docker network ls | grep "$network" > /dev/null; then
  74. bridge_interface=$("$NET_TOOLS_BASE/net-setup.sh" \
  75. --config "$NET_TOOLS_BASE/docker.conf" \
  76. start 2>/dev/null | tail -1)
  77. if [ $? != 0 ]; then
  78. echo "Could not start Docker network '$network'" >&2
  79. return 1
  80. fi
  81. echo "Started Docker network '$network' bridge interface" \
  82. "'$bridge_interface'..."
  83. fi
  84. if [ -n "$*" ]; then
  85. addresses="$*"
  86. fi
  87. if docker ps | grep "$name" > /dev/null; then
  88. docker stop "$name"
  89. fi
  90. if docker run --hostname=$name --name=$name $addresses \
  91. --rm -dit --network=$network $image > /dev/null; then
  92. echo -n "Started Docker container '$name'"
  93. if [ -n "$*" ]; then
  94. echo -n " with extra arguments '$*'"
  95. fi
  96. echo "..."
  97. else
  98. echo "Could not start Docker container '$image'"
  99. return 1
  100. fi
  101. }
  102. stop_configuration ()
  103. {
  104. local bridge_interface=""
  105. if docker ps | grep "$name" > /dev/null; then
  106. docker stop "$name" > /dev/null
  107. if [ $? -eq 0 ]; then
  108. echo "Stopped Docker container '$name'..."
  109. else
  110. echo "Could not stop Docker container '$name'" >&2
  111. fi
  112. fi
  113. bridge_interface=$(docker network ls | grep "$network" | cut -d " " -f 1)
  114. if [ -n "$bridge_interface" ]; then
  115. docker network rm "$network" > /dev/null
  116. if [ $? -eq 0 ]; then
  117. echo "Stopped Docker network '$network' bridge interface" \
  118. "'br-$bridge_interface'..."
  119. else
  120. echo "Could not stop Docker network '$network'" >&2
  121. fi
  122. fi
  123. # No need to keep the zephyr eth interface around
  124. "$NET_TOOLS_BASE/net-setup.sh" --config "$NET_TOOLS_BASE/docker.conf" \
  125. stop > /dev/null 2>&1
  126. }
  127. start_zephyr ()
  128. {
  129. if [ -n "$*" ]; then
  130. echo "Building Zephyr with additional arguments '$@'..." >&2
  131. fi
  132. rm -rf build && mkdir build && \
  133. cmake -GNinja -DBOARD=native_posix -B build "$@" . && \
  134. ninja -C build
  135. # Run the binary directly so that ninja does not print errors that
  136. # could be confusing.
  137. #ninja -C build run &
  138. build/zephyr/zephyr.exe &
  139. zephyr_pid=$!
  140. sleep 3
  141. echo "Zephyr PID $zephyr_pid"
  142. }
  143. list_children () {
  144. local pid="$(ps -o pid= --ppid "$1")"
  145. for p in $pid
  146. do
  147. list_children $p
  148. done
  149. if [ -n "$pid" ]; then
  150. echo -n "$pid "
  151. fi
  152. }
  153. stop_zephyr ()
  154. {
  155. if [ "$zephyr_pid" -ne 0 ]; then
  156. local zephyrs="$zephyr_pid $(list_children "$zephyr_pid")"
  157. echo "Stopping Zephyr PIDs $zephyrs"
  158. kill $zephyrs 2> /dev/null
  159. fi
  160. zephyr_pid=0
  161. }
  162. wait_zephyr ()
  163. {
  164. local result=""
  165. echo "Waiting for Zephyr $zephyr_pid..."
  166. wait $zephyr_pid
  167. result=$?
  168. zephyr_pid=0
  169. return $result
  170. }
  171. docker_run ()
  172. {
  173. local test=""
  174. local result=0
  175. for test in "$@"
  176. do
  177. echo "Running '$test' in the container..."
  178. docker container exec net-tools $test || return $?
  179. done
  180. }
  181. start_docker ()
  182. {
  183. docker_run "$@" &
  184. docker_pid=$!
  185. echo "Docker PID $docker_pid"
  186. }
  187. stop_docker ()
  188. {
  189. if [ "$docker_pid" -ne 0 -a "$configuration" != "keep" ]; then
  190. local dockers="$docker_pid $(list_children "$docker_pid")"
  191. echo "Stopping Docker PIDs $dockers"
  192. kill $dockers 2> /dev/null
  193. fi
  194. docker_pid=0
  195. }
  196. wait_docker ()
  197. {
  198. local result=""
  199. echo "Waiting for Docker PID $docker_pid..."
  200. wait $docker_pid
  201. result=$?
  202. docker_pid=0
  203. echo "Docker returned '$result'"
  204. return $result
  205. }
  206. run_test ()
  207. {
  208. local test="$(basename $(pwd))"
  209. local result=0
  210. local overlay=""
  211. if [ -n "$zephyr_overlay" ]; then
  212. overlay="-DOVERLAY_CONFIG=$zephyr_overlay"
  213. fi
  214. source "$1"
  215. result=$?
  216. if [ $result -eq 0 ]; then
  217. echo "Sample '$test' successful"
  218. else
  219. echo "Sample '$test' failed with return value '$result'"
  220. fi
  221. return $result
  222. }
  223. usage ()
  224. {
  225. BASENAME=`basename $0`
  226. cat <<EOF
  227. $BASENAME [-Z <zephyr base directory>] [-N <net-tools base directory>] [<list of test directories>]
  228. This script runs Zephyr sample tests using Docker container and
  229. network implemented by the 'net-tools' subproject.
  230. -Z|--zephyr-dir <dir>
  231. set Zephyr base directory
  232. -N|--net-tools-dir <dir>
  233. set net-tools directory
  234. --start
  235. only start Docker container and network and exit
  236. --stop
  237. only stop Docker container and network
  238. --keep
  239. keep Docker container and network after test
  240. --overlay <config files>
  241. additional configuration/overlay files for the Zephyr build process
  242. --scan
  243. find out the directories that can be used for this testing
  244. <list of test directories>
  245. run the tests in these directories instead of current directory
  246. The automatically detected directories are:
  247. EOF
  248. check_dirs
  249. }
  250. stop_sample_test () {
  251. echo "Interrupted..." >&2
  252. stop_zephyr
  253. stop_docker
  254. stop_configuration
  255. exit 2
  256. }
  257. trap stop_sample_test ABRT INT HUP TERM
  258. while test -n "$1"
  259. do
  260. case "$1" in
  261. -Z|--zephyr-dir)
  262. shift
  263. ZEPHYR_BASE="$1"
  264. ;;
  265. -N|--net-tools-dir)
  266. shift
  267. NET_TOOLS_BASE="$1"
  268. ;;
  269. -h|--help)
  270. usage
  271. exit
  272. ;;
  273. --start)
  274. if [ -n "$configuration" ]; then
  275. echo "--start or --stop specified multiple times" >&2
  276. exit 1
  277. fi
  278. configuration=start_only
  279. ;;
  280. --stop)
  281. if [ -n "$configuration" ]; then
  282. echo "--start or --stop specified multiple times" >&2
  283. exit 1
  284. fi
  285. configuration=stop_only
  286. ;;
  287. --keep)
  288. configuration=keep
  289. ;;
  290. --overlay)
  291. shift
  292. if [ -n "$zephyr_overlay" ]; then
  293. zephyr_overlay="$zephyr_overlay $1"
  294. else
  295. zephyr_overlay="$1"
  296. fi
  297. ;;
  298. --scan)
  299. scan_dirs=1
  300. ;;
  301. -*)
  302. echo "Argument '$1' not recognised" >&2
  303. usage
  304. return 0
  305. ;;
  306. *)
  307. dirs="$dirs $1"
  308. ;;
  309. esac
  310. shift
  311. done
  312. check_dirs || exit $?
  313. if [ $scan_dirs -eq 1 ]; then
  314. scan_dirs
  315. exit 0
  316. fi
  317. if [ -z "$configuration" -o "$configuration" = "start_only" -o \
  318. "$configuration" = "keep" ]; then
  319. if [ "$configuration" = start_only ]; then
  320. start_configuration
  321. result=$?
  322. else
  323. result=0
  324. found=0
  325. if [ -z "$dirs" ]; then
  326. dirs="."
  327. fi
  328. for d in $dirs; do
  329. if [ ! -d "$d" ]; then
  330. echo "No such directory $d, skipping it"
  331. continue
  332. fi
  333. if [ ! -f "$d/$docker_test_script_name" ]; then
  334. echo "No such file $d/$docker_test_script_name, skipping directory"
  335. continue
  336. fi
  337. found=$(expr $found + 1)
  338. CURR_DIR=`pwd`
  339. cd "$d"
  340. run_test "./$docker_test_script_name"
  341. test_result=$?
  342. cd "$CURR_DIR"
  343. if [ $test_result -ne 0 ]; then
  344. result=1
  345. fi
  346. done
  347. if [ $found -eq 0 ]; then
  348. exit 1
  349. fi
  350. fi
  351. fi
  352. if [ -z "$configuration" -o "$configuration" = stop_only ]; then
  353. stop_configuration
  354. fi
  355. exit $result